/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import AccessAndRefreshToken from '../model/AccessAndRefreshToken';
import AccessToken from '../model/AccessToken';

/**
* Auth service.
* @module ftclient/AuthApi
* @version 2021.12-dev21
*/
export default class AuthApi {

    /**
    * Constructs a new AuthApi. 
    * @alias module:ftclient/AuthApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * Token Login
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AccessAndRefreshToken} and HTTP response
     */
    tokenLoginApiV1TokenLoginPostWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = AccessAndRefreshToken;
      return this.apiClient.callApi(
        '/api/v1/token/login', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Token Login
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AccessAndRefreshToken}
     */
    tokenLoginApiV1TokenLoginPost() {
      return this.tokenLoginApiV1TokenLoginPostWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Token Refresh
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AccessToken} and HTTP response
     */
    tokenRefreshApiV1TokenRefreshPostWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = AccessToken;
      return this.apiClient.callApi(
        '/api/v1/token/refresh', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Token Refresh
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AccessToken}
     */
    tokenRefreshApiV1TokenRefreshPost() {
      return this.tokenRefreshApiV1TokenRefreshPostWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
